

fof(h1, axiom, (
    ![A,B,C]: true(c(c(A, c(B, C)), c(c(A, B), c(A, C))))
)).
fof(h2, axiom, (
    ![A,B]: true(c(A, c(B, A)))
)).
fof(h3, axiom, (
    ![A,B]: true(c(c(n(B), n(A)), c(A, B)))
)).
fof(modus_ponens, axiom, (
    ![A,B]: ((true(A) & true(c(A, B))) => true(B))
)).

% --------------------------------------------------------

%S5 is characterized by the axioms:
%
%    * K: \Box(A\to B)\to(\Box A\to\Box B);

fof(k, axiom, (
    ![A,B]: true(c(box(c(A,B)), c(box(A), box(B))))
)).

%    * T: \Box A \to A,
fof(k, axiom, (
    ![A]: true(c(box(A), A))
)).


fof(diamond, axiom, (
    ![A]: (diamond(A) = n(box(n(A))))
)).

%
%and either:
%
%    * 5: \Diamond A\to \Box\Diamond A;
%    * or both of the following:
%
%        * 4: \Box A\to\Box\Box A, and
%        * B: A\to\Box\Diamond A.

fof(ax5, axiom, (
    ![A]: true(c(diamond(A), box(diamond(A))))
)).

fof(axiom4, conjecture, (
    ![A]: true(c(box(A), box(box(A))))
)).
%fof(b, conjecture, (
%    ![A]: true(c(A, box(diamond(A))))
%)).
