cnf(k_comm, definition,
    ( k(X,Y)=k(Y,X) )).
cnf(k_assoc,definition,
    ( k(X,k(Y,Z))=k(k(X,Y),Z) )).
cnf(k_absorption, definition,
    ( k(X,a(X,Y))=X )).
cnf(k_distributivity, definition,
    ( k(X,a(Y,Z))=a(k(X,Y),k(X,Z)) )).
cnf(complements, definition,
    ( n(k(X,n(X)))=top )).
cnf(def_a, definition,
    ( a(A,B)=n(k(n(A),n(B))) )).

cnf(def_c, axiom, ( c(A,B)=n(k(A,n(B))) )).
fof(true_predicate, axiom,
    ![X]: ( true(X) <=> (X = top) )).

% --------------------------------------------------------

%S5 is characterized by the axioms:
%
%    * K: \Box(A\to B)\to(\Box A\to\Box B);

fof(k, axiom, (
    ![A,B]: true(c(box(c(A,B)), c(box(A), box(B))))
)).

%    * T: \Box A \to A,
fof(k, axiom, (
    ![A]: true(c(box(A), A))
)).


fof(diamond, axiom, (
    ![A]: (diamond(A) = n(box(n(A))))
)).

%
%and either:
%
%    * 5: \Diamond A\to \Box\Diamond A;
%    * or both of the following:
%
%        * 4: \Box A\to\Box\Box A, and
%        * B: A\to\Box\Diamond A.

fof(ax5, axiom, (
    ![A]: true(c(diamond(A), box(diamond(A))))
)).

fof(axiom4, conjecture, (
    ![A]: true(c(box(A), box(box(A))))
)).
%fof(b, conjecture, (
%    ![A]: true(c(A, box(diamond(A))))
%)).
